#pragma once
#include "template.h"
#include "surface.h"
#include "Player.h"
#include "Bullet.h"
#include "EnemyGroupData.h"

namespace Tmpl8 {

	static enum EnemyType { COMMANDER, RED, PURPLE, GREEN };
	class Surface;
	class Sprite;
	class Enemy
		: public Sprite
	{
	public:
		static enum State{ IDLE, ARC, ARCEND, RETURN, DEAD };
		Enemy(Surface* a_Surface, Surface* screen, EnemyGroupData* egd, Enemy* owner, Player* player, EnemyType type);
		~Enemy();
		EnemyType type;
		Enemy::EnemyType GetNextGroupType();
		State state = IDLE;
		void DrawEnemy();
		void Die();
		void OwnerUpdate(float DT);
		void Update(float DT);
		bool IsDead();
		bool AllDead();
		bool CanArc(float DT);
		glm::vec2 GetPosition();
		glm::vec2 position;
		glm::vec2 arcPosition;
		glm::vec2 arcPivot;
		glm::vec2 direction;
		glm::vec2 moveTowards;
		Surface* screen;
		float angle;
		float speed = 5;
		float arcSpeed;
		float updateArcTimer;
		float updateArcInterval = 0.1f;
		Player* player;

		Enemy* next = 0;
		Enemy* prevous = 0;
		EnemyGroupData* enemyGroupData;
	private:
		void CollisionUpdate();
		void Shoot();
		float radius = 40;
		glm::vec2 NormalizeVector(glm::vec2 vector);
		float arcDirection = 1;

		float returnTimer;
		float returnInterval = 3;

		Bullet* bullet = 0;
		float bulletTimer;
		float bulletInterval = 0.3f;

		float arcTimer = 2;
		Particles* explosionParticles = 0;
	};

}; // namespace Tmpl8