#include "EnemyGroupData.h"
#include "enemy.h"

using namespace Tmpl8;				// to use template classes
using namespace glm;				// to use glm vector stuff

EnemyGroupData::EnemyGroupData()
{
	commanderEnemySurface = new Surface("assets/commander.png");
	greenEnemySurface = new Surface("assets/green.png");
	purpleEnemySurface = new Surface("assets/purple.png");
	redEnemySurface = new Surface("assets/red.png");

	nextType = COMMANDER;
}

EnemyGroupData::~EnemyGroupData()
{

}


void EnemyGroupData::UpdateNext()
{
	if (rows == 0)
		nextType = COMMANDER;// Enemy::COMMANDER;
	else if (rows == 1)
		nextType = RED;//Enemy::RED;
	else if (rows == 2)
		nextType = PURPLE;//Enemy::PURPLE;
	else
		nextType = GREEN;//Enemy::GREEN;
}

Surface* EnemyGroupData::NextSurface()
{
	switch (nextType)
	{
	case COMMANDER:
		return commanderEnemySurface;
		break;
	case RED:
		return redEnemySurface;
		break;
	case PURPLE:
		return purpleEnemySurface;
		break;
	default:
		return greenEnemySurface;
	}
	return greenEnemySurface;
}

bool EnemyGroupData::Next()
{
	if (cols < MAXCOLS-1 && !(rows == 0 && cols >= MAXCOLS-4) && !(rows == 1 && cols >= MAXCOLS-3) && !(rows == 2 && cols >= MAXCOLS-2))
	{
		if (rows == 0)
		{
			cols += cols == 0 ? 4 : 2;
			if (cols >= 6)
			{
				rows++;
				cols = 2;
				UpdateNext();
				return true;
			}
		}
		cols++;
	}
	else if (rows < MAXROWS - 1)
	{
		rows++;
		if (rows == 1)
			cols = 2;
		else if (rows == 2)
			cols = 1;
		else
			cols = 0;
	}
	else 
		return false;
	UpdateNext();
	return true;
}

bool EnemyGroupData::BulletCollisionCheckUpdate(glm::vec2 bulletposition, float bulletRadius, Enemy* bulletsEnemy)
{
	glm::vec2 enemyposition = bulletsEnemy->GetPosition();
	float lengthX = (enemyposition.x + bulletsEnemy->GetWidth() / 2) - (bulletposition.x + bulletRadius);
	float lengthY = (enemyposition.y + bulletsEnemy->GetHeight() / 2) - (bulletposition.y + bulletRadius);
	float distance = glm::sqrt((lengthX * lengthX) + lengthY * lengthY);
	if (!bulletsEnemy->IsDead() && distance < bulletRadius + bulletsEnemy->GetWidth() / 2)
	{
		bulletsEnemy->Die();
		return true;
	}
	else if (bulletsEnemy->next != 0)
		return BulletCollisionCheckUpdate(bulletposition, bulletRadius, bulletsEnemy->next);
	
	return false;
	
}

glm::vec2 EnemyGroupData::GetSpawnPosition()
{
	return glm::vec2(SPACE + cols * SPACE, SPACE + rows * SPACE);
}

bool EnemyGroupData::HasNext()
{
	return !(rows == MAXROWS && cols == MAXCOLS);
}