#pragma once
#include "template.h"
#include "surface.h"

namespace Tmpl8 {
	class Surface;
	class Sprite;
	class Enemy;
	enum EnemyType;
	class EnemyGroupData
	{
	public:
		EnemyGroupData();
		~EnemyGroupData();
		bool BulletCollisionCheckUpdate(glm::vec2 bulletposition, float bulletRadius, Enemy* bulletsEnemy);
		glm::vec2 GetSpawnPosition();
		bool Next();
		bool HasNext();
		Surface* NextSurface();
		EnemyType nextType;
		//int nextType;

		bool changeDirection = false;
		glm::vec2 changeDirectionTo = glm::vec2(1, 0);

		int rows = 0;
		int cols = 3;

		glm::vec2 direction = glm::vec2(1,0);

		Surface* commanderEnemySurface;
		Surface* redEnemySurface;
		Surface* purpleEnemySurface;
		Surface* greenEnemySurface;

		const int SPACE = 50;
	private:
		void UpdateNext();
		const int MAXROWS = 6;
		const int MAXCOLS = 10;
	};

}; // namespace Tmpl8