#include "Particle.h"
#include <cmath>

using namespace Tmpl8;				// to use template classes
using namespace glm;				// to use glm vector stuff

Particle::Particle(Surface* screen)
{
	this->screen = screen;

}

Particle::~Particle()
{
	if (next != 0)
	{
		next->prevous = prevous;
	}
	if (prevous != 0)
	{
		prevous->next = next;
	}
}

void Particle::Update(float DT)
{
	lifetime -= DT / 1000;

	position.x += cos(angle / 180 * PI) * speed;
	position.y += sin(angle / 180 * PI) * speed;

	if (next != 0)
	{
		next->Update(DT);
		if (next->lifetime < 0)
		{

			delete next;
		}
	}
}

void Particle::Draw()
{
	if (lifetime > 0)
		screen->Box(position.x, position.y, position.x + 1, position.y + 1, color);

	if (next != 0)
		next->Draw();
}