#include "Particles.h"
#include <cmath>

using namespace Tmpl8;				// to use template classes
using namespace glm;				// to use glm vector stuff

Particles::Particles(Surface* screen)
{
	this->screen = screen;

}

void Particles::Emit()
{
	float amount = round(minAmount + (Rand(maxAmount) - minAmount));
	Particle* p = 0;
	int i = 0;
	do
	{
		if (p == 0)
			p = particle = new Particle(screen);
		else
		{
			p->next = new Particle(screen);
			p->next->prevous = p;
			p = p->next;
		}
		p->angle = minAngle + (Rand(maxAngle) - minAngle);
		p->lifetime = minLifetime + (Rand(maxLifeTime) - minLifetime);
		p->position = startPosition;
		p->speed = minSpeed + (Rand(maxSpeed) - minSpeed);
		p->color = color;
	} while (i++ < amount-1);
	p->next = 0;
	didEmit = true;
}

void Particles::Update(float DT)
{
	if (!didEmit)
		return;
	if (particle != 0)
		particle->Update(DT);
	if (particle->lifetime < 0 && particle->next == 0)
	{
		delete particle;
		particle = 0;
		finished = true;
	}
}

void Particles::Draw()
{
	if (!didEmit)
		return;
	if (particle != 0)
		particle->Draw();
}