#include "Star.h"
#include <iostream>

using namespace Tmpl8;				// to use template classes
using namespace glm;				// to use glm vector stuff

Star::Star(Surface* screen, int id)
{
	this->id = id;
	this->screen = screen;
	this->position = glm::vec2(Rand(screen->GetWidth()), Rand(screen->GetHeight()));

	visible = Rand(10) < 5 ? true : false;
	timer = Rand(10) / 10;
	color = Rand(10) < 8 ? 0xfdff00 : 0xffeeaa;
	if (id < 400)
		next = new Star(screen, id + 1);
	if (id == 0)
		directionTimer = directionInterval;
}

Star::~Star()
{
	if (next != 0)
		delete next;
}


void Star::Draw()
{
	if (visible)
		screen->Box(this->position.x, this->position.y, this->position.x + 1, this->position.y + 1, color);
	if (next != 0)
		next->Draw();
}

void Star::Update(float DT)
{
	this->position += speed * direction;
	if (this->position.y > screen->GetHeight())
		this->position.y = 0;
	if (this->position.x < 0)
		this->position.x = screen->GetWidth();
	else if (this->position.x > screen->GetWidth())
		this->position.x = 0;

	timer -= DT / 1000;
	if (timer <= 0)
	{
		visible = !visible;
		timer = 1;
	}

	if (id == 0)
	{
		directionTimer -= DT / 1000;
		if (directionTimer <= 0)
		{
			direction = glm::vec2((Rand(2)-1), Rand(1));
			directionTimer = directionInterval;
			speed = Rand(2);

			Star * n = next;
			while (n != 0)
			{
				n->direction = direction;
				n->speed = speed;
				n = n->next;
			}
		}
	}
	if (next != 0)
		next->Update(DT);
}