#pragma once

#define SCRWIDTH	800
#define SCRHEIGHT	600

#include "template.h"
#include "surface.h"
#include "Player.h"
#include "Star.h"
#include "EnemyGroupData.h"
#include "Enemy.h"

namespace Tmpl8 {

class Surface;
class Game
{
public:
	void SetTarget( Surface* _Surface ) { screen = _Surface; }
	void Init();
	void Shutdown();
	void Tick( float _DT );
	void MouseUp( int _Button ) { /* implement if you want to detect mouse button presses */ }
	void MouseDown( int _Button ) { /* implement if you want to detect mouse button presses */ }
	void MouseMove( int _X, int _Y ) { /* implement if you want to detect mouse movement */ }
	void KeyUp(int key);
	void KeyDown(int key);
	void PrintUI();
	void GameStart();
	void Restart();

	Player* player;
	Star* star;
	EnemyGroupData* enemyGroupData;
	Enemy* enemy;
private:
	Surface* screen;

	bool gameStarted = false;
};

}; // namespace Tmpl8